from vcCommand import *
import os.path

app = getApplication()
teach = getApplication().TeachContext

def DeleteProperties(args):
  if processStatement.Properties[14].Name != processStatement.Properties[-1].Name:
    processStatement.deleteProperty(processStatement.Properties[16])
    processStatement.deleteProperty(processStatement.Properties[15])

def CreateProperties(args):
  if app.findComponent(component.Value.Name).getProperty(componentProperties.Value[0].Name) == None:
    print "'",app.findComponent(component.Value.Name).Name,"'","not have property :",componentProperties.Value[0].Name
  
  if componentProperties.Value != [] and app.findComponent(component.Value.Name).getProperty(componentProperties.Value[0].Name) != None:
    if processStatement.Properties[14].Name != processStatement.Properties[-1].Name:
      processStatement.deleteProperty(processStatement.Properties[16])
      processStatement.deleteProperty(processStatement.Properties[15])
    
    if componentProperties.Value[0].Name == "Name":
      print "不支持更改组件名字/Changing component names is not supported"
    
    propertyType = ["String","Boolean","Integer","Real","Vector","Matrix","Expression","RealDistribution","URI","Ref<Material>","List<Ref<Component> >","List<Ref<Node> >","Ref<Component>","Ref<Node>"]
    for types in propertyType:
      if componentProperties.Value[0].Type != types:
        otherType = componentProperties.Value[0].Type
      else:
        otherType = None
        break
    if otherType != None:
      print "不支持该属性/This property is not supported ：",componentProperties.Value[0].Type
    
    if componentProperties.Value[0].Name != "Name" and componentProperties.Value[0].Type != otherType:
      print "Property Type :",componentProperties.Value[0].Type
      if componentProperties.Value[0].Type == "String":
        processStatement.createProperty(VC_STRING, componentProperties.Value[0].Name+"(Initial)")
        processStatement.createProperty(VC_STRING, componentProperties.Value[0].Name)
      if componentProperties.Value[0].Type == "Boolean":
        processStatement.createProperty(VC_BOOLEAN, componentProperties.Value[0].Name+"(Initial)")
        processStatement.createProperty(VC_BOOLEAN, componentProperties.Value[0].Name)
      if componentProperties.Value[0].Type == "Integer":
        processStatement.createProperty(VC_INTEGER, componentProperties.Value[0].Name+"(Initial)")
        processStatement.createProperty(VC_INTEGER, componentProperties.Value[0].Name)
      if componentProperties.Value[0].Type == "Real":
        processStatement.createProperty(VC_REAL, componentProperties.Value[0].Name+"(Initial)")
        processStatement.createProperty(VC_REAL, componentProperties.Value[0].Name)
      if componentProperties.Value[0].Type == "Vector":
        processStatement.createProperty(VC_VECTOR, componentProperties.Value[0].Name+"(Initial)")
        processStatement.createProperty(VC_VECTOR, componentProperties.Value[0].Name)
      if componentProperties.Value[0].Type == "Matrix":
        processStatement.createProperty(VC_MATRIX, componentProperties.Value[0].Name+"(Initial)")
        processStatement.createProperty(VC_MATRIX, componentProperties.Value[0].Name)
      if componentProperties.Value[0].Type == "Expression":
        processStatement.createProperty(VC_EXPRESSION, componentProperties.Value[0].Name+"(Initial)")
        processStatement.createProperty(VC_EXPRESSION, componentProperties.Value[0].Name)
      if componentProperties.Value[0].Type == "RealDistribution":
        processStatement.createProperty(VC_DISTRIBUTION, componentProperties.Value[0].Name+"(Initial)")
        processStatement.createProperty(VC_DISTRIBUTION, componentProperties.Value[0].Name)
      if componentProperties.Value[0].Type == "URI":
        processStatement.createProperty(VC_URI, componentProperties.Value[0].Name+"(Initial)")
        processStatement.createProperty(VC_URI, componentProperties.Value[0].Name)
      if componentProperties.Value[0].Type == "Ref<Material>":
        processStatement.createProperty("Ref<Material>", componentProperties.Value[0].Name+"(Initial)")
        processStatement.createProperty("Ref<Material>", componentProperties.Value[0].Name)
      if componentProperties.Value[0].Type == "List<Ref<Component> >":
        processStatement.createProperty("List<Ref<Component>>", componentProperties.Value[0].Name+"(Initial)")
        processStatement.createProperty("List<Ref<Component>>", componentProperties.Value[0].Name)
      if componentProperties.Value[0].Type == "List<Ref<Node> >":
        processStatement.createProperty("List<Ref<Node>>", componentProperties.Value[0].Name+"(Initial)")
        processStatement.createProperty("List<Ref<Node>>", componentProperties.Value[0].Name)
      if componentProperties.Value[0].Type == "Ref<Component>":
        processStatement.createProperty("Ref<Component>", componentProperties.Value[0].Name+"(Initial)")
        processStatement.createProperty("Ref<Component>", componentProperties.Value[0].Name)
      if componentProperties.Value[0].Type == "Ref<Node>":
        processStatement.createProperty("Ref<Node>", componentProperties.Value[0].Name+"(Initial)")
        processStatement.createProperty("Ref<Node>", componentProperties.Value[0].Name)
      
      InitialProperty = processStatement.getProperty(componentProperties.Value[0].Name+"(Initial)")
      NewProperty = processStatement.getProperty(componentProperties.Value[0].Name)
      InitialProperty.Value = app.findComponent(component.Value.Name).getProperty(componentProperties.Value[0].Name).Value
      
      if componentProperties.Value[0].Type == "String":
        if app.findComponent(component.Value.Name).getProperty(componentProperties.Value[0].Name).StepValues != None:
          processStatement.deleteProperty(processStatement.Properties[16])
          processStatement.deleteProperty(processStatement.Properties[15])
          processStatement.createProperty(VC_STRING, componentProperties.Value[0].Name+"(Initial)", VC_PROPERTY_STEP)
          processStatement.createProperty(VC_STRING, componentProperties.Value[0].Name, VC_PROPERTY_STEP)
          InitialProperty = processStatement.getProperty(componentProperties.Value[0].Name+"(Initial)")
          NewProperty = processStatement.getProperty(componentProperties.Value[0].Name)
          InitialProperty.Value = app.findComponent(component.Value.Name).getProperty(componentProperties.Value[0].Name).Value
          NewProperty.StepValues = app.findComponent(component.Value.Name).getProperty(componentProperties.Value[0].Name).StepValues
      
      print "Property created"
      
      try:
        quantity = app.findComponent(component.Value.Name).getProperty(componentProperties.Value[0].Name).Quantity
        if quantity == None:
          print "选取的属性没有定义单位/The selected property does not have a defined unit"
        if componentProperties.Value[0].Type == "Real" and quantity != None:
          InitialProperty.Quantity = app.findComponent(component.Value.Name).getProperty(componentProperties.Value[0].Name).Quantity
          NewProperty.Quantity = InitialProperty.Quantity
      except:
        print "选取的属性没有单位/The selected property has no units"
      
      InitialProperty.WritableWhenConnected = False
      InitialProperty.WritableWhenDisconnected = False
      InitialProperty.WritableWhenSimulating = False
      
    if componentProperties.Value[-1].Name != componentProperties.Value[0].Name:
      print "只能选择一个属性/Only one attribute can be selected"

def OnStart():
  routine = teach.ActiveScope
  
  icon_path = getCommandPath()[8:]
  base, filename = os.path.split(icon_path)
  icon_path = os.path.join(base, 'rProperties.svg')
  
  global processStatement
  processStatement = routine.addStatement(VC_STATEMENT_PROCESS, teach.ActiveStatementIndex + 1, icon_path)
  processStatement.Name = "Property"+str(teach.ActiveStatementIndex+1)
  
  processStatement.createProperty('Ref<Component>', 'Component')
  processStatement.createProperty('List<Ref<Parameter>>', 'Component.Properties')
  processStatement.createProperty(VC_BUTTON, 'FindProperties')
  processStatement.createProperty(VC_BUTTON, 'ClearProperties')
  processStatement.createProperty(VC_BOOLEAN, 'Reset')
  
  global component, componentProperties, findProperties, clearProperties
  component = processStatement.getProperty('Component')
  componentProperties = processStatement.getProperty('Component.Properties')
  findProperties = processStatement.getProperty('FindProperties')
  clearProperties = processStatement.getProperty('ClearProperties')
  
  findProperties.OnChanged = CreateProperties
  clearProperties.OnChanged = DeleteProperties
  
  robot = teach.ActiveRobot 
  visibleStatementScriptName = 'StatementScript_' + processStatement.Name
  visibleStatementScript = robot.findBehaviour(visibleStatementScriptName)
  if not visibleStatementScript:
    visibleStatementScript = robot.createBehaviour(VC_PYTHONPROCESSHANDLER, visibleStatementScriptName)
  visibleStatementScript.Script = '''
from vcPythonProcessHandler import *
import vcVector

app = getApplication()

def hideOthers(statement):
  name = statement.getProperty('Name')
  name.IsVisible = False
  base = statement.getProperty('Base')
  base.IsVisible = False
  tool = statement.getProperty('Tool')
  tool.IsVisible = False

def setEvents(statement):
  global component, componentProperties, reset, newProperties, initialProperties, oldProperties
  
  component = statement.getProperty('Component')
  componentProperties = statement.getProperty('Component.Properties')
  reset = statement.getProperty('Reset')
  if componentProperties.Value != []:
    newProperties = statement.getProperty(componentProperties.Value[0].Name)
    initialProperties = statement.getProperty(componentProperties.Value[0].Name+"(Initial)")
    oldProperties = app.findComponent(component.Value.Name).getProperty(componentProperties.Value[0].Name)
  
def OnStatementAdd(statement):
  # Hide others
  hideOthers(statement)
  # Set events
  setEvents(statement)

def OnStatementModified(statement):
  # Hide others
  hideOthers(statement)
  # Set events
  setEvents(statement)
  
def OnStatementExecute(executor, statement):  
  # Hide others
  hideOthers(statement)
  # Set events
  setEvents(statement)
  
  oldProperties.Value = newProperties.Value

def OnReset():
  if reset.Value == True:
    oldProperties.Value = initialProperties.Value

'''
  processStatement.Process = visibleStatementScript
  app.SelectionManager.setSelection(processStatement)

